#
#  ██╗  ██╗██╗██████╗ ██╗  ██╗██╗ █████╗ ███████╗
#  ╚██╗██╔╝██║██╔══██╗██║  ██║██║██╔══██╗██╔════╝
#   ╚███╔╝ ██║██████╔╝███████║██║███████║███████╗
#   ██╔██╗ ██║██╔═══╝ ██╔══██║██║██╔══██║╚════██║
#  ██╔╝ ██╗██║██║     ██║  ██║██║██║  ██║███████║
#  ╚═╝  ╚═╝╚═╝╚═╝     ╚═╝  ╚═╝╚═╝╚═╝  ╚═╝╚══════╝
#
# _run_every_second.mcfunction | Runs all commands that need to be run every second.
#                              | Called by 'xiphias:_run_every'
#
# Special thanks to MSpaceDev. I pulled apart the 'Player Graves' data pack to understand how functions do.
# MSpaceDev | https://www.youtube.com/c/MinecraftSpace
#

# |===| Inventory Counter |===|
execute as @a[scores={xph_inventory=0}] run gamerule keepInventory false
scoreboard players remove @a[scores={xph_inventory=0..}] xph_inventory 1
# |===========================|

# |===| Some Effects (and MOBs) are Very Annoying |===|
effect clear @a minecraft:bad_omen
replaceitem entity @e[type=minecraft:vex] weapon.mainhand minecraft:bow
# |===================================================|

# |===| Update 'Location ID' for all Players |===|
execute if score SirSecondTick xph_location_id matches 1 run scoreboard players set @a xph_location_id 1
execute if score SirSecondTick xph_location_id matches 2 run scoreboard players set @a xph_location_id 2
execute if score SirSecondTick xph_location_id matches 3 run scoreboard players set @a xph_location_id 3
execute if score SirSecondTick xph_location_id matches 4 run scoreboard players set @a xph_location_id 4
# |==============================================|

# |===| Reset TP Timer with Change of Y |===|
execute as @a store result score @s yPosTest run data get entity @s Pos[1] 1
execute as @a unless score @s yPosTest = @s yPosStore run scoreboard players set @s xph_tp_counter 0
execute as @a store result score @s yPosStore run scoreboard players get @s yPosTest
# |=========================================|

# |===| TP Players to the Correct Location |===|
#   Location 1
execute as @a[x=0,y=0,z=0,dx=400,dy=256,dz=400,scores={xph_location_id=2}] run function xiphias:teleport/back_to_a2
execute as @a[x=0,y=0,z=0,dx=400,dy=256,dz=400,scores={xph_location_id=3}] run function xiphias:teleport/back_to_a3
execute as @a[x=0,y=0,z=0,dx=400,dy=256,dz=400,scores={xph_location_id=4}] run function xiphias:teleport/back_to_a4
#   Location 2
execute as @a[x=1424,y=0,z=0,dx=400,dy=256,dz=400,scores={xph_location_id=1}] run function xiphias:teleport/back_to_a1
execute as @a[x=1424,y=0,z=0,dx=400,dy=256,dz=400,scores={xph_location_id=3}] run function xiphias:teleport/back_to_a3
execute as @a[x=1424,y=0,z=0,dx=400,dy=256,dz=400,scores={xph_location_id=4}] run function xiphias:teleport/back_to_a4
#   Location 3
execute as @a[x=1424,y=0,z=1424,dx=400,dy=256,dz=400,scores={xph_location_id=1}] run function xiphias:teleport/back_to_a1
execute as @a[x=1424,y=0,z=1424,dx=400,dy=256,dz=400,scores={xph_location_id=2}] run function xiphias:teleport/back_to_a2
execute as @a[x=1424,y=0,z=1424,dx=400,dy=256,dz=400,scores={xph_location_id=4}] run function xiphias:teleport/back_to_a4
#   Location 4
execute as @a[x=0,y=0,z=1424,dx=400,dy=256,dz=400,scores={xph_location_id=1}] run function xiphias:teleport/back_to_a1
execute as @a[x=0,y=0,z=1424,dx=400,dy=256,dz=400,scores={xph_location_id=2}] run function xiphias:teleport/back_to_a2
execute as @a[x=0,y=0,z=1424,dx=400,dy=256,dz=400,scores={xph_location_id=3}] run function xiphias:teleport/back_to_a3
# |============================================|

# |===| Teleport Counter |===|
#   Advance 'Teleport Counter'
scoreboard players add @a[scores={xph_crouch=1..,xph_location_id=1..3}] xph_tp_counter 1
#   Count down 'Crouch' and 'Sneak' stats
scoreboard players remove @a[scores={xph_crouch=1..}] xph_crouch 1
scoreboard players remove @a[scores={xph_sneak=1..}] xph_sneak 1
scoreboard players remove @a[scores={xph_swim=1..}] xph_swim 1
scoreboard players remove @a[scores={xph_dive=1..}] xph_dive 1
#   Reset 'Teleport Counter' if (Crouch=False) or (Sneak=True)
scoreboard players set @a[scores={xph_crouch=0,xph_tp_counter=1..}] xph_tp_counter 0
scoreboard players set @a[scores={xph_sneak=1..,xph_tp_counter=1..}] xph_tp_counter 0
scoreboard players set @a[scores={xph_swim=1..,xph_tp_counter=1..}] xph_tp_counter 0
scoreboard players set @a[scores={xph_dive=1..,xph_tp_counter=1..}] xph_tp_counter 0
# |==========================|

# |===| Teleport Dazzle |===|
execute at @a[scores={xph_tp_counter=3}] run particle minecraft:cloud ~ ~ ~ 1 1 1 0 40 normal @a
execute at @a[scores={xph_tp_counter=4}] run particle minecraft:cloud ~ ~ ~ 1 1 1 0 60 normal @a
execute at @a[scores={xph_tp_counter=5}] run particle minecraft:cloud ~ ~ ~ 1 1 1 0 80 normal @a
# |=========================|

# |===| Teleport |===|
#   Activate Teleport
execute as @p[scores={xph_tp_counter=5..,xph_location_id=1..3}] run function xiphias:teleport/to_a4
# |==================|

# |===| MOB Control |===|
#   Disabled Everywhere
tp @e[type=minecraft:phantom] 1000 -256 1000
tp @e[type=minecraft:bat] 1000 -256 1000
tp @e[type=minecraft:villager] 1000 -256 1000
tp @e[type=minecraft:pig] 1000 -256 1000
tp @e[type=minecraft:parrot] 1000 -256 1000
tp @e[type=minecraft:wandering_trader] 1000 -256 1000
#   Clear Invalid Hacienda MOBs
tp @e[x=0,y=0,z=0,dx=400,dy=256,dz=400,type=minecraft:sheep] 1000 -256 1000
#tp @e[x=0,y=0,z=0,dx=400,dy=256,dz=400,type=minecraft:chicken] 1000 -256 1000
#tp @e[x=0,y=0,z=0,dx=400,dy=256,dz=400,type=minecraft:cow] 1000 -256 1000
#   Clear Invalid Truskeia MOBs
#tp @e[x=1424,y=0,z=0,dx=400,dy=256,dz=400,type=minecraft:sheep] 1000 -256 1000
tp @e[x=1424,y=0,z=0,dx=400,dy=256,dz=400,type=minecraft:chicken] 1000 -256 1000
tp @e[x=1424,y=0,z=0,dx=400,dy=256,dz=400,type=minecraft:cow] 1000 -256 1000
#   Clear Invalid Bahreev MOBs
tp @e[x=1424,y=0,z=1424,dx=400,dy=256,dz=400,type=minecraft:sheep] 1000 -256 1000
tp @e[x=1424,y=0,z=1424,dx=400,dy=256,dz=400,type=minecraft:chicken] 1000 -256 1000
tp @e[x=1424,y=0,z=1424,dx=400,dy=256,dz=400,type=minecraft:cow] 1000 -256 1000
# |=====================|

# |===| Lucky Rabbits |===|
execute unless score SirSecondTick xph_rabbit1 matches 1 run execute as @p[tag=yellow_wool,x=1572,y=65,z=388,distance=..32] run function xiphias:lucky/rabbit1
execute unless score SirSecondTick xph_rabbit2 matches 1 run execute as @p[tag=yellow_wool,x=1723,y=70,z=314,distance=..32] run function xiphias:lucky/rabbit2
execute unless score SirSecondTick xph_rabbit3 matches 1 run execute as @p[tag=yellow_wool,x=1613,y=60,z=324,distance=..32] run function xiphias:lucky/rabbit3
execute unless score SirSecondTick xph_rabbit4 matches 1 run execute as @p[tag=yellow_wool,x=1596,y=61,z=386,distance=..32] run function xiphias:lucky/rabbit4
execute unless score SirSecondTick xph_rabbit5 matches 1 run execute as @p[tag=yellow_wool,x=1511,y=58,z=334,distance=..32] run function xiphias:lucky/rabbit5
# |=======================|

# |===| Blast Mines Commands |===|
#   Blast Mines Area 1, Creepers
execute as @e[type=minecraft:creeper,sort=random,limit=1,x=1474,y=40,z=1685,dx=74,dy=30,dz=65,tag=!BlastCreeper] run function xiphias:blast_mines/blast_creeper_1a
execute as @e[type=minecraft:creeper,sort=random,limit=1,x=1474,y=40,z=1685,dx=74,dy=30,dz=65,tag=!BlastCreeper] run function xiphias:blast_mines/blast_creeper_1b
execute as @e[type=minecraft:creeper,sort=random,limit=1,x=1474,y=40,z=1685,dx=74,dy=30,dz=65,tag=!BlastCreeper] run function xiphias:blast_mines/blast_creeper_1c
#   Blast Mines Area 2, Creepers
execute as @e[type=minecraft:creeper,sort=random,limit=1,x=1549,y=32,z=1658,dx=51,dy=28,dz=107,tag=!BlastCreeper] run function xiphias:blast_mines/blast_creeper_2a
execute as @e[type=minecraft:creeper,sort=random,limit=1,x=1549,y=32,z=1658,dx=51,dy=28,dz=107,tag=!BlastCreeper] run function xiphias:blast_mines/blast_creeper_2b
execute as @e[type=minecraft:creeper,sort=random,limit=1,x=1549,y=32,z=1658,dx=51,dy=28,dz=107,tag=!BlastCreeper] run function xiphias:blast_mines/blast_creeper_2c
#   Blast Mines Area 3, Creepers
execute as @e[type=minecraft:creeper,sort=random,limit=1,x=1570,y=0,z=1686,dx=40,dy=31,dz=72,tag=!BlastCreeper] run function xiphias:blast_mines/blast_creeper_3a
execute as @e[type=minecraft:creeper,sort=random,limit=1,x=1570,y=0,z=1686,dx=40,dy=31,dz=72,tag=!BlastCreeper] run function xiphias:blast_mines/blast_creeper_3b
execute as @e[type=minecraft:creeper,sort=random,limit=1,x=1570,y=0,z=1686,dx=40,dy=31,dz=72,tag=!BlastCreeper] run function xiphias:blast_mines/blast_creeper_3c
#   Creeper Particles
execute at @e[type=minecraft:creeper,tag=Blaster] run particle minecraft:happy_villager ~ ~-1 ~ .5 .5 .5 0 50 normal
execute at @e[type=minecraft:creeper,tag=Tank] run particle minecraft:flame ~ ~1 ~ .5 .5 .5 0 3 normal
#   Creeper Effects
effect give @e[type=minecraft:creeper,tag=res0a] minecraft:resistance 1 0 true
effect give @e[type=minecraft:creeper,tag=res1a] minecraft:resistance 1 1 true
effect give @e[type=minecraft:creeper,tag=res2a] minecraft:resistance 1 2 true
effect give @e[type=minecraft:creeper,tag=spe0a] minecraft:speed 1 0 true
effect give @e[type=minecraft:creeper,tag=spe1a] minecraft:speed 1 1 true
effect give @e[type=minecraft:creeper,tag=spe3a] minecraft:speed 1 3 true
effect give @e[type=minecraft:creeper,tag=Tank] minecraft:slowness 1 0 true
effect give @e[type=minecraft:creeper,tag=Potion] minecraft:weakness 7 1 false
effect give @e[type=minecraft:creeper,tag=Potion] minecraft:hunger 3 60 false
effect give @e[type=minecraft:creeper,tag=Potion] minecraft:blindness 2 0 false
#   Blast Mines Mining Fatigue
effect give @a[tag=!purple_wool,x=1474,y=40,z=1685,dx=74,dy=30,dz=65] minecraft:mining_fatigue 10 0 true
effect give @a[tag=!purple_wool,x=1549,y=32,z=1658,dx=51,dy=28,dz=107] minecraft:mining_fatigue 10 0 true
effect give @a[tag=!purple_wool,x=1570,y=0,z=1686,dx=40,dy=31,dz=72] minecraft:mining_fatigue 10 0 true
# |==============================|

# |===| Execute if Win Condition is Met |===|
execute as @p[tag=white_wool,tag=yellow_wool,tag=lime_wool,tag=light_blue_wool,tag=purple_wool,tag=orange_wool,tag=red_wool,tag=!map_done] run function xiphias:_winner_winner
# |=========================================|

# END OF LINE.